// to represent a checking account in a bank
public class Checking implements IAccount{
	
	private int accountNum;  // Must be unique
	private int balance;     // Must remain above zero
	private String name;     // The name of account
	private int minimum;     // The minimum amount a customer is allowed to have
                           // in the account at any particular point in time.

	public Checking(int accountNum, int balance, String name, int minimum){
		this.accountNum = accountNum;
		this.balance = balance;
		this.name = name;
		this.minimum = minimum;
	}
	
	/* TEMPLATE:
	 * FIELDS:
	 * 	... accountNum ...    -- int
	 * 	... balance ...       -- int
	 * 	... name ...          -- String
	 *  ... minimum ...       -- int
	 *  
	 *  METHODS:
	 *  ... deposit(int amt) ...     -- IAccount
	 *  ... withdraw(int amt) ...    -- IAccount
	 */
	
	// produce an updated account after depositing the given amount
	public IAccount deposit(int amt){
		return new Checking(this.accountNum, this.balance + amt, 
		                    this.name, this.minimum);
	}
	
	// produce an updated account after withdrawing the given amount
	public IAccount withdraw(int amt){
		if (this.balance - this.minimum >= amt){
			return new Checking(this.accountNum, this.balance - amt, 
                          this.name, this.minimum);
		}
		else {
			throw new RuntimeException("Insufficient Funds in the checking account");
		}
	}
}
