// to represent a line of credit account in a bank
public class Credit implements IAccount{
	
	int accountNum;  // Must be unique
	int balance;     // Must remain above zero
	String name;     // The name of account
	int creditLine;  // he total amount of money they may have access to.
	double interest;  // The APR at which they are charged
	
	public Credit(int accountNum, int balance, String name,
			          int creditLine, double interest){
		this.accountNum = accountNum;
		this.balance = balance;
		this.name = name;
		this.creditLine = creditLine;
		this.interest = interest;
		
	}
	
	/* TEMPLATE:
	 * FIELDS:
	 * 	... accountNum ...    -- int
	 * 	... balance ...       -- int
	 * 	... name ...          -- String
	 * 	... creditLine ...    -- int
	 *  ... interest ...      -- double
	 *  
	 *  METHODS:
	 *  ... deposit(int amt) ...     -- IAccount
	 *  ... withdraw(int amt) ...    -- IAccount
	 */
		
	
	// produce an updated account after paying off the given amount
	public IAccount deposit(int amt){
		if(balance - amt < 0){
			throw new RuntimeException("Cannot have a credit on your account.");
		}else{
			return new Credit(this.accountNum, this.balance - amt, 
                        this.name, this.creditLine, this.interest);
		}
	}

	// produce an updated account after borrowing the given amount
	public IAccount withdraw(int amt){
		if(balance + amt > creditLine) {
			throw new RuntimeException("Cannot spend above your credit line.");
		} else {
			return new Credit(this.accountNum, this.balance + amt, 
                        this.name, this.creditLine, this.interest);
		}
	}
}

