import tester.*;

public class Examples {

	// The default constructor.
	public Examples(){}
	
	//Initialize the checking accounts.
  IAccount check1 = new Checking(0001, 0, "First Checking Account", 0);
  IAccount check2 = new Checking(0002, 100, "Second Checking Account", 50);
  IAccount check3 = new Checking(0003, 500, "Third Checking Account", 0);
		
	//Initialize the savings accounts.
  IAccount savings1 = new Savings(0004, 0, "First Savings Account", 4.9);
  IAccount savings2 = new Savings(0005, 100, "Second Savings Account", 8.9);
  IAccount savings3 = new Savings(0006, 0, "Third Savings Account", 1.1);
	
	//Initialize the savings accounts.
  // 1000 credit line approved, 1000 borrowed already
  IAccount credit1 = new Credit(0004, 1000, "First Credit Account", 1000, 4.9);
  // 200 credit line approved, 100 borrowed already
  IAccount credit2 = new Credit(0005, 100, "Second Credit Account", 200, 8.9);
  // 1000 credit line approved, no money borrowed yet
  IAccount credit3 = new Credit(0006, 0, "Third Credit Account", 1000, 1.1);
	
	// Tests the exceptions we expect to be thrown when
	// performing an "illegal" action.
	public boolean testExceptions(Tester t){
		return
		
		// test that check1.withdraw(100) throws a RuntimeException
		// with the message "Insufficient Funds".
		t.checkExpect(
				// optional description of the test case
				"The test should pass, we supplied the right information",
				
				// the exception we expect to throw
				new RuntimeException("Insufficient Funds in the checking account"),
				
				// the object that invokes the method that throws the exception
				check1,
				
				// the name of the method that should throw exception
				"withdraw",
				
				// arguments for the method invocation - as many as are needed, or none
				100
				) &&
				
		// test that savings1.withdraw(100) throws a RuntimeException
		// with the message "Insufficient Funds".
		t.checkExpect(
				"The test should pass, we supplied the right information",
				new RuntimeException("Insufficient Funds in the savings account"),
				savings1,
				"withdraw",
				100
				);
		
	}

	//Tests the withdraw methods inside certain accounts.
	public boolean testWithdraw(Tester t){
		return
		t.checkExpect(check2.withdraw(49), 
				new Checking(0002, 51, "Second Checking Account", 50)) &&
		t.checkExpect(savings2.withdraw(100), 
				new Savings(0005, 0, "Second Savings Account", 8.9)) &&
		t.checkExpect(credit2.withdraw(100), 
				new Credit(0005, 200, "Second Credit Account", 200, 8.9));
	}
	
	//Tests the deposit methods inside certain accounts.
	public boolean testDeposit(Tester t){
	  return
		t.checkExpect(check1.deposit(100), 
				new Checking(0001, 100, "First Checking Account", 0)) &&
		t.checkExpect(check2.deposit(500), 
				new Checking(0002, 600, "Second Checking Account", 50)) &&
		t.checkExpect(savings1.deposit(100), 
				new Savings(0004, 100, "First Savings Account", 4.9)) &&
		t.checkExpect(savings2.deposit(100),
				new Savings(0005, 200, "Second Savings Account", 8.9)) &&
		t.checkExpect(credit1.deposit(100),
				new Credit(0004, 900, "First Credit Account", 1000, 4.9)) &&
		t.checkExpect(credit2.deposit(100), 
				new Credit(0005, 0, "Second Credit Account", 200, 8.9));
	}
	

}
