// to represent a savings account in a bank
public class Savings implements IAccount{
	
	int accountNum;  // Must be unique
	int balance;     // Must remain above zero
	String name;     // The name of account
	double interest; // The interest rate at which their money grows.
	
	Savings(int accountNum, int balance, String name, double interest){
		this.accountNum = accountNum;
		this.balance = balance;
		this.name = name;
		this.interest = interest;
	}
	
	/* TEMPLATE:
	 * FIELDS:
	 * 	... accountNum ...    -- int
	 * 	... balance ...       -- int
	 * 	... name ...          -- String
	 *  ... interest ...      -- double
	 *  
	 *  METHODS:
	 *  ... deposit(int amt) ...     -- IAccount
	 *  ... withdraw(int amt) ...    -- IAccount
	 */
		
	// produce an updated account after depositing the given amount
	public IAccount deposit(int amt){
		return new Savings(this.accountNum, this.balance + amt, 
		                    this.name, this.interest);
	}
	
	// produce an updated account after withdrawing the given amount
	public IAccount withdraw(int amt){
		if (this.balance >= amt){
			return new Savings(this.accountNum, this.balance - amt, 
                          this.name, this.interest);
		}
		else {
			throw new RuntimeException("Insufficient Funds in the savings account");
		}
	}
}
